'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _React$PropTypes = _react2.default.PropTypes,
    node = _React$PropTypes.node,
    oneOfType = _React$PropTypes.oneOfType,
    string = _React$PropTypes.string,
    array = _React$PropTypes.array;

var Img = function (_Component) {
  (0, _inherits3.default)(Img, _Component);

  function Img() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Img);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Img.__proto__ || (0, _getPrototypeOf2.default)(Img)).call.apply(_ref, [this].concat(args))), _this), _this.state = { currentIndex: 0, isLoading: true, isLoaded: false }, _this.sourceList = [], _this.onLoad = function () {
      return _this.setState({ isLoaded: true });
    }, _this.onError = function () {
      // currentIndex is zero bases, length is 1 based.
      _this.setState({ currentIndex: ++_this.state.currentIndex });

      // if we have no more sources to try, return - we are done
      if (_this.state.currentIndex >= _this.sourceList.length) return _this.setState({ isLoading: false });

      // otherwise, try the next img
      _this.loadImg();
    }, _this.loadImg = function () {
      _this.i = new Image();
      _this.i.src = _this.sourceList[_this.state.currentIndex];
      _this.i.onload = _this.onLoad;
      _this.i.onerror = _this.onError;
    }, _this.unloadImg = function () {
      _this.i.onerror = null;
      _this.i.onload = null;
      _this.i.src = null;
      _this.i = null;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Img, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.sourceList = this.props.src && typeof this.props.src === 'string' ? [this.props.src] : this.props.src;

      // if we dont have any sources, jump directly to fallback
      if (!this.sourceList.length) return this.setState({ isLoading: false, isLoaded: false });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      // kick off process
      this.loadImg();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // ensure that we dont leave any lingering listeners
      this.unloadImg();
    }
  }, {
    key: 'render',
    value: function render() {
      // if we have loaded, show img
      if (this.state.isLoaded) {
        // clear non img props
        var _props = this.props,
            src = _props.src,
            loader = _props.loader,
            unloader = _props.unloader,
            rest = (0, _objectWithoutProperties3.default)(_props, ['src', 'loader', 'unloader']); //eslint-disable-line

        return _react2.default.createElement('img', (0, _extends3.default)({ src: this.sourceList[this.state.currentIndex] }, rest));
      }

      // if we are still trying to load, show img and a loader if requested
      if (!this.state.isLoaded && this.state.isLoading) return this.props.loader ? this.props.loader : null;

      // if we have given up on loading, show a place holder if requested, or nothing
      if (!this.state.isLoaded && !this.state.isLoading) return this.props.unloader ? this.props.unloader : null;
    }
  }]);
  return Img;
}(_react.Component);

Img.defaultProps = {
  loader: false,
  unloader: false,
  src: []
};
process.env.NODE_ENV !== "production" ? Img.propTypes = {
  loader: node,
  unloader: node,
  src: oneOfType([string, array])
} : void 0;
exports.default = Img;